/* A Bison parser, made by GNU Bison 3.4.1.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2019 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         parser_parse
#define yylex           parser_lex
#define yyerror         parser_error
#define yydebug         parser_debug
#define yynerrs         parser_nerrs


/* First part of user prologue.  */
#line 19 "parser.y"


#include "vbscript.h"
#include "parse.h"

#include "wine/debug.h"

WINE_DEFAULT_DEBUG_CHANNEL(vbscript);

static int parser_error(parser_ctx_t *,const char*);

static void parse_complete(parser_ctx_t*,BOOL);
static void handle_isexpression_script(parser_ctx_t *ctx, expression_t *expr);

static void source_add_statement(parser_ctx_t*,statement_t*);
static void source_add_class(parser_ctx_t*,class_decl_t*);

static void *new_expression(parser_ctx_t*,expression_type_t,size_t);
static expression_t *new_bool_expression(parser_ctx_t*,VARIANT_BOOL);
static expression_t *new_string_expression(parser_ctx_t*,const WCHAR*);
static expression_t *new_long_expression(parser_ctx_t*,expression_type_t,LONG);
static expression_t *new_double_expression(parser_ctx_t*,double);
static expression_t *new_unary_expression(parser_ctx_t*,expression_type_t,expression_t*);
static expression_t *new_binary_expression(parser_ctx_t*,expression_type_t,expression_t*,expression_t*);
static expression_t *new_new_expression(parser_ctx_t*,const WCHAR*);

static member_expression_t *new_member_expression(parser_ctx_t*,expression_t*,const WCHAR*);
static call_expression_t *new_call_expression(parser_ctx_t*,expression_t*,expression_t*);
static call_expression_t *make_call_expression(parser_ctx_t*,expression_t*,expression_t*);

static void *new_statement(parser_ctx_t*,statement_type_t,size_t);
static statement_t *new_call_statement(parser_ctx_t*,BOOL,expression_t*);
static statement_t *new_assign_statement(parser_ctx_t*,expression_t*,expression_t*);
static statement_t *new_set_statement(parser_ctx_t*,member_expression_t*,expression_t*,expression_t*);
static statement_t *new_dim_statement(parser_ctx_t*,dim_decl_t*);
static statement_t *new_redim_statement(parser_ctx_t*,const WCHAR*,BOOL,expression_t*);
static statement_t *new_while_statement(parser_ctx_t*,statement_type_t,expression_t*,statement_t*);
static statement_t *new_forto_statement(parser_ctx_t*,const WCHAR*,expression_t*,expression_t*,expression_t*,statement_t*);
static statement_t *new_foreach_statement(parser_ctx_t*,const WCHAR*,expression_t*,statement_t*);
static statement_t *new_if_statement(parser_ctx_t*,expression_t*,statement_t*,elseif_decl_t*,statement_t*);
static statement_t *new_function_statement(parser_ctx_t*,function_decl_t*);
static statement_t *new_onerror_statement(parser_ctx_t*,BOOL);
static statement_t *new_const_statement(parser_ctx_t*,const_decl_t*);
static statement_t *new_select_statement(parser_ctx_t*,expression_t*,case_clausule_t*);
static statement_t *new_with_statement(parser_ctx_t*,expression_t*,statement_t*);

static dim_decl_t *new_dim_decl(parser_ctx_t*,const WCHAR*,BOOL,dim_list_t*);
static dim_list_t *new_dim(parser_ctx_t*,unsigned,dim_list_t*);
static elseif_decl_t *new_elseif_decl(parser_ctx_t*,expression_t*,statement_t*);
static function_decl_t *new_function_decl(parser_ctx_t*,const WCHAR*,function_type_t,unsigned,arg_decl_t*,statement_t*);
static arg_decl_t *new_argument_decl(parser_ctx_t*,const WCHAR*,BOOL);
static const_decl_t *new_const_decl(parser_ctx_t*,const WCHAR*,expression_t*);
static case_clausule_t *new_case_clausule(parser_ctx_t*,expression_t*,statement_t*,case_clausule_t*);

static class_decl_t *new_class_decl(parser_ctx_t*);
static class_decl_t *add_class_function(parser_ctx_t*,class_decl_t*,function_decl_t*);
static class_decl_t *add_dim_prop(parser_ctx_t*,class_decl_t*,dim_decl_t*,unsigned);

static statement_t *link_statements(statement_t*,statement_t*);

#define STORAGE_IS_PRIVATE    1
#define STORAGE_IS_DEFAULT    2

#define CHECK_ERROR if(((parser_ctx_t*)ctx)->hres != S_OK) YYABORT


#line 143 "parser.tab.c"

# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_PARSER_PARSER_TAB_H_INCLUDED
# define YY_PARSER_PARSER_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int parser_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    tEXPRESSION = 258,
    tEOF = 259,
    tNL = 260,
    tEMPTYBRACKETS = 261,
    tLTEQ = 262,
    tGTEQ = 263,
    tNEQ = 264,
    tSTOP = 265,
    tME = 266,
    tREM = 267,
    tDOT = 268,
    tTRUE = 269,
    tFALSE = 270,
    tNOT = 271,
    tAND = 272,
    tOR = 273,
    tXOR = 274,
    tEQV = 275,
    tIMP = 276,
    tIS = 277,
    tMOD = 278,
    tCALL = 279,
    tSUB = 280,
    tFUNCTION = 281,
    tGET = 282,
    tLET = 283,
    tCONST = 284,
    tDIM = 285,
    tREDIM = 286,
    tPRESERVE = 287,
    tIF = 288,
    tELSE = 289,
    tELSEIF = 290,
    tEND = 291,
    tTHEN = 292,
    tEXIT = 293,
    tWHILE = 294,
    tWEND = 295,
    tDO = 296,
    tLOOP = 297,
    tUNTIL = 298,
    tFOR = 299,
    tTO = 300,
    tEACH = 301,
    tIN = 302,
    tSELECT = 303,
    tCASE = 304,
    tWITH = 305,
    tBYREF = 306,
    tBYVAL = 307,
    tOPTION = 308,
    tNOTHING = 309,
    tEMPTY = 310,
    tNULL = 311,
    tCLASS = 312,
    tSET = 313,
    tNEW = 314,
    tPUBLIC = 315,
    tPRIVATE = 316,
    tNEXT = 317,
    tON = 318,
    tRESUME = 319,
    tGOTO = 320,
    tIdentifier = 321,
    tString = 322,
    tDEFAULT = 323,
    tERROR = 324,
    tEXPLICIT = 325,
    tPROPERTY = 326,
    tSTEP = 327,
    tInt = 328,
    tDouble = 329
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 91 "parser.y"

    const WCHAR *string;
    statement_t *statement;
    expression_t *expression;
    member_expression_t *member;
    elseif_decl_t *elseif;
    dim_decl_t *dim_decl;
    dim_list_t *dim_list;
    function_decl_t *func_decl;
    arg_decl_t *arg_decl;
    class_decl_t *class_decl;
    const_decl_t *const_decl;
    case_clausule_t *case_clausule;
    unsigned uint;
    LONG integer;
    BOOL boolean;
    double dbl;

#line 280 "parser.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif



int parser_parse (parser_ctx_t *ctx);

#endif /* !YY_PARSER_PARSER_TAB_H_INCLUDED  */



#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  50
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1190

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  91
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  66
/* YYNRULES -- Number of rules.  */
#define YYNRULES  244
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  422

#define YYUNDEFTOK  2
#define YYMAXUTOK   329

/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  ((unsigned) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    85,     2,
      77,    78,    88,    86,    81,    82,    80,    89,    79,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    75,     2,
      84,    76,    83,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,    87,     2,    90,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   153,   153,   154,   157,   158,   161,   162,   163,   166,
     167,   170,   171,   172,   175,   176,   179,   180,   183,   186,
     187,   188,   189,   190,   193,   195,   196,   198,   199,   201,
     202,   204,   207,   210,   211,   212,   213,   214,   215,   216,
     217,   219,   220,   221,   222,   223,   225,   227,   229,   233,
     234,   235,   239,   240,   243,   244,   247,   248,   249,   252,
     253,   256,   257,   260,   263,   264,   267,   268,   271,   272,
     275,   277,   278,   282,   283,   286,   287,   290,   291,   294,
     298,   299,   302,   303,   304,   308,   309,   312,   313,   316,
     317,   320,   321,   322,   325,   326,   329,   330,   333,   334,
     337,   338,   341,   342,   345,   346,   349,   350,   353,   354,
     357,   358,   359,   360,   361,   362,   363,   364,   367,   368,
     371,   372,   373,   376,   377,   380,   381,   385,   386,   388,
     392,   393,   396,   397,   398,   401,   402,   403,   406,   407,
     408,   412,   413,   414,   415,   416,   417,   418,   421,   422,
     423,   426,   427,   430,   431,   434,   437,   438,   439,   441,
     443,   445,   446,   447,   448,   451,   453,   455,   459,   461,
     465,   466,   469,   470,   471,   474,   475,   478,   479,   482,
     483,   484,   488,   489,   490,   491,   492,   493,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   553,   554,   555,   556
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "tEXPRESSION", "tEOF", "tNL",
  "tEMPTYBRACKETS", "tLTEQ", "tGTEQ", "tNEQ", "tSTOP", "tME", "tREM",
  "tDOT", "tTRUE", "tFALSE", "tNOT", "tAND", "tOR", "tXOR", "tEQV", "tIMP",
  "tIS", "tMOD", "tCALL", "tSUB", "tFUNCTION", "tGET", "tLET", "tCONST",
  "tDIM", "tREDIM", "tPRESERVE", "tIF", "tELSE", "tELSEIF", "tEND",
  "tTHEN", "tEXIT", "tWHILE", "tWEND", "tDO", "tLOOP", "tUNTIL", "tFOR",
  "tTO", "tEACH", "tIN", "tSELECT", "tCASE", "tWITH", "tBYREF", "tBYVAL",
  "tOPTION", "tNOTHING", "tEMPTY", "tNULL", "tCLASS", "tSET", "tNEW",
  "tPUBLIC", "tPRIVATE", "tNEXT", "tON", "tRESUME", "tGOTO", "tIdentifier",
  "tString", "tDEFAULT", "tERROR", "tEXPLICIT", "tPROPERTY", "tSTEP",
  "tInt", "tDouble", "':'", "'='", "'('", "')'", "'0'", "'.'", "','",
  "'-'", "'>'", "'<'", "'&'", "'+'", "'\\\\'", "'*'", "'/'", "'^'",
  "$accept", "Program", "OptionExplicit_opt", "SourceElements",
  "ExpressionNl_opt", "BodyStatements", "StatementsNl_opt", "StatementsNl",
  "StatementNl", "Statement", "SimpleStatement", "MemberExpression",
  "Preserve_opt", "DimDeclList", "DimDecl", "DimList", "ConstDeclList",
  "ConstDecl", "ConstExpression", "DoType", "Step_opt", "IfStatement",
  "EndIf_opt", "ElseIfs_opt", "ElseIfs", "ElseIf", "Else_opt",
  "CaseClausules", "Arguments", "Arguments_opt", "ArgumentList_opt",
  "ArgumentList", "EmptyBrackets_opt", "ExpressionList", "Expression",
  "EqvExpression", "XorExpression", "OrExpression", "AndExpression",
  "NotExpression", "EqualityExpression", "ConcatExpression",
  "AdditiveExpression", "ModExpression", "IntdivExpression",
  "MultiplicativeExpression", "ExpExpression", "SignExpression",
  "UnaryExpression", "CallExpression", "LiteralExpression",
  "NumericLiteralExpression", "IntegerValue", "PrimaryExpression",
  "ClassDeclaration", "ClassBody", "PropertyDecl", "FunctionDecl",
  "Storage_opt", "Storage", "ArgumentsDecl_opt", "ArgumentDeclList",
  "ArgumentDecl", "Identifier", "DotIdentifier", "StSep", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,    58,    61,    40,    41,    48,
      46,    44,    45,    62,    60,    38,    43,    92,    42,    47,
      94
};
# endif

#define YYPACT_NINF -310

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-310)))

#define YYTABLE_NINF -171

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      38,   476,   -55,    26,  -310,  -310,  1118,  -310,  -310,   476,
    -310,  -310,  -310,   186,  -310,  -310,  -310,  -310,  -310,  -310,
    -310,  -310,  -310,   476,  -310,   505,   505,    35,  -310,    29,
      24,    50,    36,    55,  -310,    57,    69,   -46,   135,    80,
      68,    84,  -310,  -310,     5,  -310,  -310,  -310,  -310,    33,
    -310,   579,  -310,  -310,  -310,  -310,  -310,  -310,  -310,  -310,
    -310,  -310,  -310,  -310,  -310,  -310,  -310,  -310,  -310,  -310,
    -310,  -310,  -310,  -310,  -310,  -310,  -310,  -310,  -310,  -310,
    -310,  -310,  -310,  -310,  -310,  -310,  -310,  -310,  -310,  -310,
    -310,  -310,  -310,  -310,  -310,  -310,  -310,  -310,  -310,  -310,
    -310,  -310,  -310,  -310,  -310,  -310,  -310,  -310,    25,  -310,
    -310,  -310,  -310,   476,   476,   476,   476,   476,   505,   505,
     505,   505,   505,   505,   505,   505,   505,   505,   505,   505,
     505,   505,   505,  -310,   400,  1118,  -310,    33,    33,  -310,
    -310,  -310,   665,   186,   186,   140,   476,    30,   476,    19,
     226,   131,   476,   186,   176,   116,  -310,   124,   730,  -310,
     185,   126,  -310,   326,  -310,  -310,    85,  -310,  -310,    24,
      50,    36,    55,  -310,    69,    69,    69,    69,    69,    69,
      69,   -46,   135,   135,    80,    68,    84,    84,  -310,   400,
     118,     6,  -310,  -310,  -310,  -310,  -310,   125,   138,  -310,
     130,     3,  -310,   136,    22,  -310,  -310,  -310,  -310,  -310,
      32,  -310,  -310,   476,   784,   186,   139,   476,    32,    33,
      13,     5,  -310,    66,  -310,  -310,   730,   476,   400,  -310,
    -310,   186,   186,  -310,  -310,   400,   186,   121,   186,  -310,
     -22,   142,   633,   838,    32,   178,  -310,   730,   174,   476,
      32,   892,    82,  -310,   146,   161,   145,  -310,   208,    -8,
      23,    23,  -310,  -310,    92,  -310,  -310,  -310,  -310,  -310,
     153,   154,   400,   730,    27,   194,   784,   106,  -310,   476,
       7,   187,   201,   186,   203,    33,    33,    42,   177,   476,
    -310,  -310,  -310,   358,  -310,    33,    33,  -310,  -310,   -22,
     162,   215,  1054,   218,  -310,  -310,   219,   476,    32,   476,
     429,   224,   212,    33,   206,    82,    82,    20,    33,   208,
     186,   186,   188,   184,   262,   946,   946,  -310,  -310,   476,
     235,  -310,   215,   234,  -310,  -310,   208,  1000,     9,    33,
      33,    11,   223,  -310,    82,    33,  -310,  -310,   214,   216,
     217,    82,   262,   262,  -310,   358,  -310,   242,   946,   185,
     245,    39,   281,   252,  -310,  -310,   231,   476,    33,  1054,
     730,   476,  -310,  -310,  -310,    23,   222,   227,  -310,  -310,
    -310,  -310,   275,  -310,   277,   296,   892,   272,  -310,   208,
    1000,  -310,   187,  -310,    33,   358,   358,  -310,  -310,   730,
    -310,  -310,   244,  -310,   946,   230,   233,  -310,  -310,   276,
      33,    33,   247,   946,   946,  -310,   280,   283,   249,   250,
    -310,  -310
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       4,     9,     0,     0,     6,   154,     0,   141,   142,     0,
     147,   145,   146,     0,   182,   143,   183,   184,   185,   186,
     187,   149,   150,     0,   148,     0,     0,     0,   139,     0,
      98,   100,   102,   104,   106,   108,   110,   118,   120,   123,
     125,   127,   130,   132,   136,   135,   144,   138,    49,     0,
       1,   170,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   201,   202,   203,   204,   205,   200,   239,
     240,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   238,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   188,    51,   109,   137,     0,   133,
     134,     3,    10,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    85,     0,     0,   140,   241,   242,     5,
       2,    41,     0,     0,     0,    52,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   173,   174,     0,    19,     7,
       0,    21,    29,    89,     8,    34,     0,   171,   153,    99,
     101,   103,   105,   107,   116,   115,   112,   117,   111,   113,
     114,   119,   122,   121,   124,   126,   128,   129,   131,     0,
       0,    91,    50,   243,   244,    25,    44,    61,     0,    27,
      54,    56,    53,     0,     0,    39,    37,    35,    36,    38,
       0,    66,    67,     0,   170,     0,     0,     0,     0,     0,
      87,     0,   172,     0,    20,    18,    23,     0,     0,    24,
      90,     0,     0,    93,    86,     0,     0,     0,     0,    58,
       0,     0,   170,   170,     0,     0,    15,    16,     0,     0,
       0,   170,   170,    88,     0,     0,     0,    22,    26,     0,
      94,    94,    92,    62,     0,    63,    64,    55,   152,   151,
       0,    59,     0,    14,    73,     0,   170,    33,    17,     0,
       0,    82,     0,     0,     0,   163,   157,     0,   171,     0,
      42,    43,    95,     0,   175,     0,     0,    65,    57,     0,
       0,    75,   170,     0,    71,    30,     0,     0,     0,     0,
       0,     0,     0,   161,     0,   170,   170,     0,   159,    40,
       0,     0,     0,   177,    94,   170,   170,    60,    28,     0,
      80,    76,    77,    73,    74,    31,    32,   170,    68,     0,
       0,    96,     0,    48,   170,     0,   164,   158,     0,     0,
       0,   170,    94,    94,   176,     0,   179,     0,   170,    12,
       0,     0,     0,     0,    78,    72,     0,     0,     0,   170,
      14,     0,    47,   162,   155,    94,     0,     0,   160,   180,
     181,   178,     0,    13,     0,     0,   170,     0,    46,    69,
     170,    83,    82,    97,     0,     0,     0,   168,   169,    14,
      81,    70,     0,    84,   170,     0,     0,    79,    45,     0,
       0,     0,     0,   170,   170,   165,     0,     0,     0,     0,
     166,   167
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -310,  -310,  -310,  -310,  -310,  -309,  -231,  -243,   -41,  -140,
    -310,   159,  -310,    86,    43,    28,    89,  -310,  -310,    45,
    -310,  -310,    -3,  -310,     1,  -310,  -310,   -64,   111,  -310,
    -310,  -158,  -171,   -33,     0,   232,   229,   221,   228,    -1,
    -310,   238,   225,    -5,   220,   236,    67,    -4,   204,   -35,
     110,    88,  -310,  -310,  -310,  -152,  -310,  -227,  -219,  -217,
    -255,    -2,  -226,    -6,   239,  -135
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     3,     4,    51,    27,   357,   245,   246,   247,   160,
     161,    28,   203,   199,   200,   270,   196,   197,   265,   213,
     368,   162,   304,   330,   331,   332,   363,   311,   136,   254,
     229,   190,   294,   340,   191,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,   271,    47,   164,   284,   285,   165,   166,   167,
     295,   322,   323,    48,   105,   139
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     104,    29,   193,   194,   278,   230,   296,   107,   106,   239,
     159,   133,   275,   113,   214,    49,   163,   360,   224,   133,
     282,   109,   110,   108,   137,   286,    50,   113,   113,   292,
     113,   233,   113,   287,   112,   288,   126,   137,   137,   111,
     127,     1,   301,   113,   114,   306,   113,   348,   349,   383,
     113,   268,   309,   113,   116,   205,   206,   269,   211,   242,
     113,   302,   212,   303,   118,   119,   120,   231,   232,   115,
     168,   207,   117,   235,   208,   243,   385,   262,   350,   121,
     240,   367,   134,   251,   252,   135,   257,   235,   286,   286,
     134,     2,   371,  -139,   138,   409,   287,   287,   288,   288,
     293,   209,   274,   168,   416,   417,   366,   138,   138,   276,
     231,   232,   283,   317,   300,   281,   173,   286,  -156,   221,
     394,   182,   183,   163,   286,   287,   391,   288,   188,   104,
     255,   256,   287,   122,   288,     7,     8,   198,   201,   392,
     123,   124,   155,   156,   216,   211,   204,   219,   210,   212,
     315,   316,   218,   356,   125,   400,   130,   131,   128,   402,
     325,   326,   333,   346,   347,    21,    22,   129,   407,   405,
     406,    24,   202,   337,   132,    10,    11,    12,   344,   163,
     217,   379,   380,   351,   222,   359,   359,     5,    15,     6,
     225,   163,   373,   223,    21,    22,   234,   186,   187,   378,
      24,   226,   241,   264,   369,   370,   236,   163,   163,   248,
     374,   238,   163,   244,   237,   249,   163,   250,   359,   272,
     277,   279,   289,   290,   291,   260,   261,   258,   259,   113,
     198,   298,   201,   390,   305,   299,   310,   312,   163,   314,
     328,   163,    14,   318,    16,    17,    18,    19,    20,   280,
     329,   334,    14,    23,    16,    17,    18,    19,    20,   404,
     342,   335,   343,   345,   359,   355,   354,   163,   292,   362,
     303,   372,   215,   359,   359,   413,   414,   201,   382,   308,
     375,   384,   376,   377,   358,   358,   386,   324,   387,   319,
     163,   163,    14,   388,    16,    17,    18,    19,    20,   395,
     397,   399,   163,   398,   396,   401,   408,   336,   410,   338,
     341,   411,   412,   220,   352,   353,   418,   358,   415,   419,
     420,   421,   307,   163,   267,   263,   313,   327,   403,   361,
     365,   253,   133,   364,   163,   163,   171,     5,   393,     6,
       7,     8,     9,   170,   172,   169,   195,   266,   184,   324,
     181,   163,   297,   381,     0,   163,   174,   175,   176,   177,
     178,   179,   180,   358,   163,   185,     0,   389,     0,   163,
       0,   341,   358,   358,   192,     0,     0,     0,   163,   163,
      10,    11,    12,     0,     0,    13,     0,     0,     0,   324,
     324,     0,    14,    15,    16,    17,    18,    19,    20,    21,
      22,     0,   227,   228,     0,    24,   135,   189,    25,   320,
     321,     5,    26,     6,     7,     8,     9,     0,     0,     0,
       0,     0,     0,     0,    14,     0,    16,    17,    18,    19,
      20,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       5,     0,     6,     7,     8,     9,     0,     0,     0,     0,
       0,     0,     0,     0,    10,    11,    12,     0,     0,    13,
       0,     0,     0,   339,     0,     0,    14,    15,    16,    17,
      18,    19,    20,    21,    22,     0,     0,    23,     0,    24,
       0,   189,    25,    10,    11,    12,    26,     5,    13,     6,
       7,     8,     9,     0,     0,    14,    15,    16,    17,    18,
      19,    20,    21,    22,     0,     0,    23,     0,    24,     0,
       0,    25,     0,     0,     0,    26,     5,     0,     6,     7,
       8,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      10,    11,    12,     0,     0,    13,     0,     0,     0,     0,
       0,     0,    14,    15,    16,    17,    18,    19,    20,    21,
      22,     0,     0,    23,     0,    24,     0,     0,    25,    10,
      11,    12,    26,     0,    13,     0,     0,     0,     0,     0,
       0,    14,    15,    16,    17,    18,    19,    20,    21,    22,
       0,     0,    23,   140,    24,     0,     0,    25,     0,   141,
       5,    26,     6,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   142,     0,     0,     0,     0,   143,   144,
     145,     0,   146,     0,     0,     0,     0,   147,   148,     0,
     149,     0,     0,   150,     0,     0,     0,   151,     0,   152,
       0,     0,     0,     0,     0,     0,   153,   154,   273,   155,
     156,     0,   157,   141,     5,    14,     6,    16,    17,    18,
      19,    20,     0,     0,   158,     0,    23,   142,     0,     0,
       0,     0,   143,   144,   145,     0,   146,     0,     0,     0,
       0,   147,   148,     0,   149,     0,     5,   150,     6,     7,
       8,   151,     0,   152,     0,     0,     0,     0,     0,     0,
       0,   154,     0,   155,   156,     0,   157,     0,     0,    14,
       0,    16,    17,    18,    19,    20,     0,     0,   158,     0,
      23,     0,     0,     0,     0,     0,     0,     0,     0,    10,
      11,    12,     0,     0,    13,     0,     0,     0,     0,     0,
       0,    14,    15,    16,    17,    18,    19,    20,    21,    22,
     141,     5,    23,     6,    24,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   142,  -170,  -170,     0,     0,   143,
     144,   145,     0,   146,     0,     0,     0,     0,   147,   148,
       0,   149,     0,     0,   150,     0,     0,     0,   151,     0,
     152,     0,     0,     0,     0,     0,     0,     0,   154,     0,
     155,   156,     0,   157,   141,     5,    14,     6,    16,    17,
      18,    19,    20,     0,     0,   158,     0,    23,   142,     0,
       0,     0,     0,   143,   144,   145,     0,   146,     0,     0,
       0,     0,   147,   148,     0,   149,   -14,     0,   150,     0,
       0,     0,   151,     0,   152,     0,     0,     0,     0,     0,
       0,     0,   154,     0,   155,   156,     0,   157,   141,     5,
      14,     6,    16,    17,    18,    19,    20,     0,     0,   158,
       0,    23,   142,     0,     0,     0,     0,   143,   144,   145,
       0,   146,     0,     0,     0,     0,   147,   148,   -14,   149,
       0,     0,   150,     0,     0,     0,   151,     0,   152,     0,
       0,     0,     0,     0,     0,     0,   154,     0,   155,   156,
       0,   157,   141,     5,    14,     6,    16,    17,    18,    19,
      20,     0,     0,   158,     0,    23,   142,     0,     0,     0,
       0,   143,   144,   145,     0,   146,     0,     0,   -14,     0,
     147,   148,     0,   149,     0,     0,   150,     0,     0,     0,
     151,     0,   152,     0,     0,     0,     0,     0,     0,     0,
     154,     0,   155,   156,     0,   157,   141,     5,    14,     6,
      16,    17,    18,    19,    20,     0,     0,   158,     0,    23,
     142,     0,     0,     0,     0,   143,   144,   145,     0,   146,
       0,     0,   -11,     0,   147,   148,     0,   149,     0,     0,
     150,     0,     0,     0,   151,     0,   152,     0,     0,     0,
       0,     0,     0,     0,   154,     0,   155,   156,     0,   157,
     141,     5,    14,     6,    16,    17,    18,    19,    20,     0,
       0,   158,     0,    23,   142,     0,     0,     0,     0,   143,
     144,   145,     0,   146,     0,     0,     0,     0,   147,   148,
       0,   149,     0,     0,   150,     0,     0,     0,   151,     0,
     152,     0,     0,     0,     0,     0,     0,     0,   154,     0,
     155,   156,   -14,   157,   141,     5,    14,     6,    16,    17,
      18,    19,    20,     0,     0,   158,     0,    23,   142,     0,
       0,     0,     0,   143,   144,   145,     0,   146,     0,     0,
       0,     0,   147,   148,     0,   149,     0,     0,   150,     0,
       0,     0,   151,     0,   152,     0,     0,     0,     0,     0,
       0,     0,   154,     0,   155,   156,     0,   157,     0,     0,
      14,     0,    16,    17,    18,    19,    20,     0,     0,   158,
       0,    23,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    14,     0,    16,    17,    18,    19,
      20
};

static const yytype_int16 yycheck[] =
{
       6,     1,   137,   138,   247,   163,   261,    13,     9,     6,
      51,     6,   243,    21,   149,    70,    51,   326,   158,     6,
     251,    25,    26,    23,     5,   252,     0,    21,    21,     6,
      21,   189,    21,   252,     5,   252,    82,     5,     5,     4,
      86,     3,   273,    21,    20,   276,    21,    27,    28,   358,
      21,    73,    45,    21,    18,    25,    26,    79,    39,    37,
      21,    34,    43,    36,     7,     8,     9,    25,    26,    19,
      78,    41,    17,    81,    44,   210,    37,   235,    58,    22,
      77,    72,    77,   218,   219,    80,   226,    81,   315,   316,
      77,    53,    81,    80,    75,   404,   315,   316,   315,   316,
      77,    71,   242,    78,   413,   414,   337,    75,    75,   244,
      25,    26,    30,    71,   272,   250,   117,   344,    36,   154,
     375,   126,   127,   158,   351,   344,   369,   344,   132,   135,
      64,    65,   351,    76,   351,    14,    15,   143,   144,   370,
      83,    84,    60,    61,   150,    39,   146,   153,   148,    43,
     285,   286,   152,   324,    85,   386,    88,    89,    23,   390,
     295,   296,   302,   315,   316,    73,    74,    87,   399,   395,
     396,    79,    32,   308,    90,    54,    55,    56,   313,   214,
      49,   352,   353,   318,    68,   325,   326,    11,    67,    13,
       5,   226,   344,    69,    73,    74,    78,   130,   131,   351,
      79,    75,    66,    82,   339,   340,    81,   242,   243,   215,
     345,    81,   247,   213,    76,    76,   251,   217,   358,    77,
      42,    47,    76,    62,    79,   231,   232,   227,   228,    21,
     236,    78,   238,   368,    40,    81,    49,    36,   273,    36,
      78,   276,    66,    66,    68,    69,    70,    71,    72,   249,
      35,    33,    66,    77,    68,    69,    70,    71,    72,   394,
      36,    42,    50,    57,   404,    81,    78,   302,     6,    34,
      36,    48,    46,   413,   414,   410,   411,   283,    36,   279,
      66,    36,    66,    66,   325,   326,     5,   293,    36,   289,
     325,   326,    66,    62,    68,    69,    70,    71,    72,    77,
      25,     5,   337,    26,    77,    33,    62,   307,    78,   309,
     310,    78,    36,   154,   320,   321,    36,   358,    71,    36,
      71,    71,   277,   358,   238,   236,   283,   299,   392,   329,
     333,   220,     6,   332,   369,   370,   115,    11,   371,    13,
      14,    15,    16,   114,   116,   113,   142,   237,   128,   355,
     125,   386,   264,   355,    -1,   390,   118,   119,   120,   121,
     122,   123,   124,   404,   399,   129,    -1,   367,    -1,   404,
      -1,   371,   413,   414,   135,    -1,    -1,    -1,   413,   414,
      54,    55,    56,    -1,    -1,    59,    -1,    -1,    -1,   395,
     396,    -1,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    -1,    76,    77,    -1,    79,    80,    81,    82,    51,
      52,    11,    86,    13,    14,    15,    16,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    66,    -1,    68,    69,    70,    71,
      72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      11,    -1,    13,    14,    15,    16,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    54,    55,    56,    -1,    -1,    59,
      -1,    -1,    -1,    34,    -1,    -1,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    -1,    -1,    77,    -1,    79,
      -1,    81,    82,    54,    55,    56,    86,    11,    59,    13,
      14,    15,    16,    -1,    -1,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    -1,    -1,    77,    -1,    79,    -1,
      -1,    82,    -1,    -1,    -1,    86,    11,    -1,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      54,    55,    56,    -1,    -1,    59,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    -1,    -1,    77,    -1,    79,    -1,    -1,    82,    54,
      55,    56,    86,    -1,    59,    -1,    -1,    -1,    -1,    -1,
      -1,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      -1,    -1,    77,     4,    79,    -1,    -1,    82,    -1,    10,
      11,    86,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,    29,    30,
      31,    -1,    33,    -1,    -1,    -1,    -1,    38,    39,    -1,
      41,    -1,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,
      -1,    -1,    -1,    -1,    -1,    -1,    57,    58,     5,    60,
      61,    -1,    63,    10,    11,    66,    13,    68,    69,    70,
      71,    72,    -1,    -1,    75,    -1,    77,    24,    -1,    -1,
      -1,    -1,    29,    30,    31,    -1,    33,    -1,    -1,    -1,
      -1,    38,    39,    -1,    41,    -1,    11,    44,    13,    14,
      15,    48,    -1,    50,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    58,    -1,    60,    61,    -1,    63,    -1,    -1,    66,
      -1,    68,    69,    70,    71,    72,    -1,    -1,    75,    -1,
      77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,
      55,    56,    -1,    -1,    59,    -1,    -1,    -1,    -1,    -1,
      -1,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      10,    11,    77,    13,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    24,    25,    26,    -1,    -1,    29,
      30,    31,    -1,    33,    -1,    -1,    -1,    -1,    38,    39,
      -1,    41,    -1,    -1,    44,    -1,    -1,    -1,    48,    -1,
      50,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,
      60,    61,    -1,    63,    10,    11,    66,    13,    68,    69,
      70,    71,    72,    -1,    -1,    75,    -1,    77,    24,    -1,
      -1,    -1,    -1,    29,    30,    31,    -1,    33,    -1,    -1,
      -1,    -1,    38,    39,    -1,    41,    42,    -1,    44,    -1,
      -1,    -1,    48,    -1,    50,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    58,    -1,    60,    61,    -1,    63,    10,    11,
      66,    13,    68,    69,    70,    71,    72,    -1,    -1,    75,
      -1,    77,    24,    -1,    -1,    -1,    -1,    29,    30,    31,
      -1,    33,    -1,    -1,    -1,    -1,    38,    39,    40,    41,
      -1,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,    60,    61,
      -1,    63,    10,    11,    66,    13,    68,    69,    70,    71,
      72,    -1,    -1,    75,    -1,    77,    24,    -1,    -1,    -1,
      -1,    29,    30,    31,    -1,    33,    -1,    -1,    36,    -1,
      38,    39,    -1,    41,    -1,    -1,    44,    -1,    -1,    -1,
      48,    -1,    50,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      58,    -1,    60,    61,    -1,    63,    10,    11,    66,    13,
      68,    69,    70,    71,    72,    -1,    -1,    75,    -1,    77,
      24,    -1,    -1,    -1,    -1,    29,    30,    31,    -1,    33,
      -1,    -1,    36,    -1,    38,    39,    -1,    41,    -1,    -1,
      44,    -1,    -1,    -1,    48,    -1,    50,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    58,    -1,    60,    61,    -1,    63,
      10,    11,    66,    13,    68,    69,    70,    71,    72,    -1,
      -1,    75,    -1,    77,    24,    -1,    -1,    -1,    -1,    29,
      30,    31,    -1,    33,    -1,    -1,    -1,    -1,    38,    39,
      -1,    41,    -1,    -1,    44,    -1,    -1,    -1,    48,    -1,
      50,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,
      60,    61,    62,    63,    10,    11,    66,    13,    68,    69,
      70,    71,    72,    -1,    -1,    75,    -1,    77,    24,    -1,
      -1,    -1,    -1,    29,    30,    31,    -1,    33,    -1,    -1,
      -1,    -1,    38,    39,    -1,    41,    -1,    -1,    44,    -1,
      -1,    -1,    48,    -1,    50,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    58,    -1,    60,    61,    -1,    63,    -1,    -1,
      66,    -1,    68,    69,    70,    71,    72,    -1,    -1,    75,
      -1,    77,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    -1,    68,    69,    70,    71,
      72
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,    53,    92,    93,    11,    13,    14,    15,    16,
      54,    55,    56,    59,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    77,    79,    82,    86,    95,   102,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   144,   154,    70,
       0,    94,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,   154,   155,   130,   154,   125,   138,
     138,     4,     5,    21,    20,    19,    18,    17,     7,     8,
       9,    22,    76,    83,    84,    85,    82,    86,    23,    87,
      88,    89,    90,     6,    77,    80,   119,     5,    75,   156,
       4,    10,    24,    29,    30,    31,    33,    38,    39,    41,
      44,    48,    50,    57,    58,    60,    61,    63,    75,    99,
     100,   101,   112,   140,   145,   148,   149,   150,    78,   126,
     127,   128,   129,   130,   132,   132,   132,   132,   132,   132,
     132,   133,   134,   134,   135,   136,   137,   137,   138,    81,
     122,   125,   155,   156,   156,   139,   107,   108,   154,   104,
     105,   154,    32,   103,   125,    25,    26,    41,    44,    71,
     125,    39,    43,   110,   156,    46,   154,    49,   125,   154,
     102,   140,    68,    69,   100,     5,    75,    76,    77,   121,
     122,    25,    26,   122,    78,    81,    81,    76,    81,     6,
      77,    66,    37,   156,   125,    97,    98,    99,   154,    76,
     125,   156,   156,   119,   120,    64,    65,   100,   125,   125,
     154,   154,   122,   107,    82,   109,   141,   104,    73,    79,
     106,   143,    77,     5,   100,    97,   156,    42,    98,    47,
     125,   156,    97,    30,   146,   147,   148,   149,   150,    76,
      62,    79,     6,    77,   123,   151,   151,   142,    78,    81,
     122,    97,    34,    36,   113,    40,    97,   110,   125,    45,
      49,   118,    36,   105,    36,   156,   156,    71,    66,   125,
      51,    52,   152,   153,   154,   156,   156,   106,    78,    35,
     114,   115,   116,   100,    33,    42,   125,   156,   125,    34,
     124,   125,    36,    50,   156,    57,   146,   146,    27,    28,
      58,   156,   154,   154,    78,    81,   123,    96,    99,   100,
      96,   125,    34,   117,   115,   113,    97,    72,   111,   156,
     156,    81,    48,   146,   156,    66,    66,    66,   146,   123,
     123,   152,    36,    96,    36,    37,     5,    36,    62,   125,
     156,    98,    97,   124,   151,    77,    77,    25,    26,     5,
      97,    33,    97,   118,   156,   153,   153,    97,    62,    96,
      78,    78,    36,   156,   156,    71,    96,    96,    36,    36,
      71,    71
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    91,    92,    92,    93,    93,    94,    94,    94,    95,
      95,    96,    96,    96,    97,    97,    98,    98,    99,   100,
     100,   100,   100,   100,   101,   101,   101,   101,   101,   101,
     101,   101,   101,   101,   101,   101,   101,   101,   101,   101,
     101,   101,   101,   101,   101,   101,   101,   101,   101,   102,
     102,   102,   103,   103,   104,   104,   105,   105,   105,   106,
     106,   107,   107,   108,   109,   109,   110,   110,   111,   111,
     112,   112,   112,   113,   113,   114,   114,   115,   115,   116,
     117,   117,   118,   118,   118,   119,   119,   120,   120,   121,
     121,   122,   122,   122,   123,   123,   124,   124,   125,   125,
     126,   126,   127,   127,   128,   128,   129,   129,   130,   130,
     131,   131,   131,   131,   131,   131,   131,   131,   132,   132,
     133,   133,   133,   134,   134,   135,   135,   136,   136,   136,
     137,   137,   138,   138,   138,   139,   139,   139,   140,   140,
     140,   141,   141,   141,   141,   141,   141,   141,   142,   142,
     142,   143,   143,   144,   144,   145,   146,   146,   146,   146,
     146,   146,   146,   146,   146,   147,   147,   147,   148,   148,
     149,   149,   150,   150,   150,   151,   151,   152,   152,   153,
     153,   153,   154,   154,   154,   154,   154,   154,   155,   155,
     155,   155,   155,   155,   155,   155,   155,   155,   155,   155,
     155,   155,   155,   155,   155,   155,   155,   155,   155,   155,
     155,   155,   155,   155,   155,   155,   155,   155,   155,   155,
     155,   155,   155,   155,   155,   155,   155,   155,   155,   155,
     155,   155,   155,   155,   155,   155,   155,   155,   155,   155,
     155,   156,   156,   156,   156
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     3,     3,     0,     3,     0,     2,     2,     0,
       2,     0,     1,     2,     0,     1,     1,     2,     2,     1,
       2,     1,     3,     2,     2,     2,     3,     2,     6,     1,
       5,     6,     6,     4,     1,     2,     2,     2,     2,     2,
       5,     1,     4,     4,     2,    10,     8,     7,     6,     1,
       3,     2,     0,     1,     1,     3,     1,     4,     2,     1,
       3,     1,     3,     3,     1,     2,     1,     1,     0,     2,
       9,     5,     7,     0,     2,     0,     1,     1,     2,     5,
       0,     3,     0,     4,     5,     1,     3,     0,     1,     0,
       1,     1,     3,     2,     0,     1,     1,     3,     1,     3,
       1,     3,     1,     3,     1,     3,     1,     3,     1,     2,
       1,     3,     3,     3,     3,     3,     3,     3,     1,     3,
       1,     3,     3,     1,     3,     1,     3,     1,     3,     3,
       1,     3,     1,     2,     2,     1,     1,     2,     1,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     7,     0,     1,     3,     2,
       4,     2,     4,     1,     3,     9,    11,    11,     8,     8,
       0,     1,     2,     1,     1,     1,     3,     1,     3,     2,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (ctx, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, ctx); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, parser_ctx_t *ctx)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (ctx);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, parser_ctx_t *ctx)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyo, yytype, yyvaluep, ctx);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, parser_ctx_t *ctx)
{
  unsigned long yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                                              , ctx);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, ctx); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return (YYSIZE_T) (yystpcpy (yyres, yystr) - yyres);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, parser_ctx_t *ctx)
{
  YYUSE (yyvaluep);
  YYUSE (ctx);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (parser_ctx_t *ctx)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yynewstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  *yyssp = (yytype_int16) yystate;

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = (YYSIZE_T) (yyssp - yyss + 1);

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, ctx);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2:
#line 153 "parser.y"
    { parse_complete(ctx, (yyvsp[-2].boolean)); }
#line 1857 "parser.tab.c"
    break;

  case 3:
#line 154 "parser.y"
    { handle_isexpression_script(ctx, (yyvsp[-1].expression)); }
#line 1863 "parser.tab.c"
    break;

  case 4:
#line 157 "parser.y"
    { (yyval.boolean) = FALSE; }
#line 1869 "parser.tab.c"
    break;

  case 5:
#line 158 "parser.y"
    { (yyval.boolean) = TRUE; }
#line 1875 "parser.tab.c"
    break;

  case 7:
#line 162 "parser.y"
    { source_add_statement(ctx, (yyvsp[0].statement)); }
#line 1881 "parser.tab.c"
    break;

  case 8:
#line 163 "parser.y"
    { source_add_class(ctx, (yyvsp[0].class_decl)); }
#line 1887 "parser.tab.c"
    break;

  case 9:
#line 166 "parser.y"
    { (yyval.expression) = NULL; }
#line 1893 "parser.tab.c"
    break;

  case 10:
#line 167 "parser.y"
    { (yyval.expression) = (yyvsp[-1].expression); }
#line 1899 "parser.tab.c"
    break;

  case 11:
#line 170 "parser.y"
    { (yyval.statement) = NULL; }
#line 1905 "parser.tab.c"
    break;

  case 12:
#line 171 "parser.y"
    { (yyval.statement) = (yyvsp[0].statement); }
#line 1911 "parser.tab.c"
    break;

  case 13:
#line 172 "parser.y"
    { (yyval.statement) = link_statements((yyvsp[-1].statement), (yyvsp[0].statement)); }
#line 1917 "parser.tab.c"
    break;

  case 14:
#line 175 "parser.y"
    { (yyval.statement) = NULL; }
#line 1923 "parser.tab.c"
    break;

  case 15:
#line 176 "parser.y"
    { (yyval.statement) = (yyvsp[0].statement); }
#line 1929 "parser.tab.c"
    break;

  case 16:
#line 179 "parser.y"
    { (yyval.statement) = (yyvsp[0].statement); }
#line 1935 "parser.tab.c"
    break;

  case 17:
#line 180 "parser.y"
    { (yyval.statement) = link_statements((yyvsp[-1].statement), (yyvsp[0].statement)); }
#line 1941 "parser.tab.c"
    break;

  case 18:
#line 183 "parser.y"
    { (yyval.statement) = (yyvsp[-1].statement); }
#line 1947 "parser.tab.c"
    break;

  case 19:
#line 186 "parser.y"
    { (yyval.statement) = NULL; }
#line 1953 "parser.tab.c"
    break;

  case 20:
#line 187 "parser.y"
    { (yyval.statement) = (yyvsp[0].statement); }
#line 1959 "parser.tab.c"
    break;

  case 21:
#line 188 "parser.y"
    { (yyval.statement) = (yyvsp[0].statement); }
#line 1965 "parser.tab.c"
    break;

  case 22:
#line 189 "parser.y"
    { (yyvsp[-2].statement)->next = (yyvsp[0].statement); (yyval.statement) = (yyvsp[-2].statement); }
#line 1971 "parser.tab.c"
    break;

  case 23:
#line 190 "parser.y"
    { (yyval.statement) = (yyvsp[-1].statement); }
#line 1977 "parser.tab.c"
    break;

  case 24:
#line 193 "parser.y"
    { call_expression_t *call_expr = make_call_expression(ctx, (yyvsp[-1].expression), (yyvsp[0].expression)); CHECK_ERROR;
                                              (yyval.statement) = new_call_statement(ctx, FALSE, &call_expr->expr); CHECK_ERROR; }
#line 1984 "parser.tab.c"
    break;

  case 25:
#line 195 "parser.y"
    { (yyval.statement) = new_call_statement(ctx, TRUE, (yyvsp[0].expression)); CHECK_ERROR; }
#line 1990 "parser.tab.c"
    break;

  case 26:
#line 197 "parser.y"
    { (yyval.statement) = new_assign_statement(ctx, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 1996 "parser.tab.c"
    break;

  case 27:
#line 198 "parser.y"
    { (yyval.statement) = new_dim_statement(ctx, (yyvsp[0].dim_decl)); CHECK_ERROR; }
#line 2002 "parser.tab.c"
    break;

  case 28:
#line 200 "parser.y"
    { (yyval.statement) = new_redim_statement(ctx, (yyvsp[-3].string), (yyvsp[-4].boolean), (yyvsp[-1].expression)); CHECK_ERROR; }
#line 2008 "parser.tab.c"
    break;

  case 29:
#line 201 "parser.y"
    { (yyval.statement) = (yyvsp[0].statement); }
#line 2014 "parser.tab.c"
    break;

  case 30:
#line 203 "parser.y"
    { (yyval.statement) = new_while_statement(ctx, STAT_WHILE, (yyvsp[-3].expression), (yyvsp[-1].statement)); CHECK_ERROR; }
#line 2020 "parser.tab.c"
    break;

  case 31:
#line 205 "parser.y"
    { (yyval.statement) = new_while_statement(ctx, (yyvsp[-4].boolean) ? STAT_WHILELOOP : STAT_UNTIL, (yyvsp[-3].expression), (yyvsp[-1].statement));
                                              CHECK_ERROR; }
#line 2027 "parser.tab.c"
    break;

  case 32:
#line 208 "parser.y"
    { (yyval.statement) = new_while_statement(ctx, (yyvsp[-1].boolean) ? STAT_DOWHILE : STAT_DOUNTIL, (yyvsp[0].expression), (yyvsp[-3].statement));
                                              CHECK_ERROR; }
#line 2034 "parser.tab.c"
    break;

  case 33:
#line 210 "parser.y"
    { (yyval.statement) = new_while_statement(ctx, STAT_DOWHILE, NULL, (yyvsp[-1].statement)); CHECK_ERROR; }
#line 2040 "parser.tab.c"
    break;

  case 34:
#line 211 "parser.y"
    { (yyval.statement) = new_function_statement(ctx, (yyvsp[0].func_decl)); CHECK_ERROR; }
#line 2046 "parser.tab.c"
    break;

  case 35:
#line 212 "parser.y"
    { (yyval.statement) = new_statement(ctx, STAT_EXITDO, 0); CHECK_ERROR; }
#line 2052 "parser.tab.c"
    break;

  case 36:
#line 213 "parser.y"
    { (yyval.statement) = new_statement(ctx, STAT_EXITFOR, 0); CHECK_ERROR; }
#line 2058 "parser.tab.c"
    break;

  case 37:
#line 214 "parser.y"
    { (yyval.statement) = new_statement(ctx, STAT_EXITFUNC, 0); CHECK_ERROR; }
#line 2064 "parser.tab.c"
    break;

  case 38:
#line 215 "parser.y"
    { (yyval.statement) = new_statement(ctx, STAT_EXITPROP, 0); CHECK_ERROR; }
#line 2070 "parser.tab.c"
    break;

  case 39:
#line 216 "parser.y"
    { (yyval.statement) = new_statement(ctx, STAT_EXITSUB, 0); CHECK_ERROR; }
#line 2076 "parser.tab.c"
    break;

  case 40:
#line 218 "parser.y"
    { (yyval.statement) = new_set_statement(ctx, (yyvsp[-3].member), (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2082 "parser.tab.c"
    break;

  case 41:
#line 219 "parser.y"
    { (yyval.statement) = new_statement(ctx, STAT_STOP, 0); CHECK_ERROR; }
#line 2088 "parser.tab.c"
    break;

  case 42:
#line 220 "parser.y"
    { (yyval.statement) = new_onerror_statement(ctx, TRUE); CHECK_ERROR; }
#line 2094 "parser.tab.c"
    break;

  case 43:
#line 221 "parser.y"
    { (yyval.statement) = new_onerror_statement(ctx, FALSE); CHECK_ERROR; }
#line 2100 "parser.tab.c"
    break;

  case 44:
#line 222 "parser.y"
    { (yyval.statement) = new_const_statement(ctx, (yyvsp[0].const_decl)); CHECK_ERROR; }
#line 2106 "parser.tab.c"
    break;

  case 45:
#line 224 "parser.y"
    { (yyval.statement) = new_forto_statement(ctx, (yyvsp[-8].string), (yyvsp[-6].expression), (yyvsp[-4].expression), (yyvsp[-3].expression), (yyvsp[-1].statement)); CHECK_ERROR; }
#line 2112 "parser.tab.c"
    break;

  case 46:
#line 226 "parser.y"
    { (yyval.statement) = new_foreach_statement(ctx, (yyvsp[-5].string), (yyvsp[-3].expression), (yyvsp[-1].statement)); }
#line 2118 "parser.tab.c"
    break;

  case 47:
#line 228 "parser.y"
    { (yyval.statement) = new_select_statement(ctx, (yyvsp[-4].expression), (yyvsp[-2].case_clausule)); }
#line 2124 "parser.tab.c"
    break;

  case 48:
#line 230 "parser.y"
    { (yyval.statement) = new_with_statement(ctx, (yyvsp[-4].expression), (yyvsp[-2].statement)); }
#line 2130 "parser.tab.c"
    break;

  case 49:
#line 233 "parser.y"
    { (yyval.member) = new_member_expression(ctx, NULL, (yyvsp[0].string)); CHECK_ERROR; }
#line 2136 "parser.tab.c"
    break;

  case 50:
#line 234 "parser.y"
    { (yyval.member) = new_member_expression(ctx, (yyvsp[-2].expression), (yyvsp[0].string)); CHECK_ERROR; }
#line 2142 "parser.tab.c"
    break;

  case 51:
#line 235 "parser.y"
    { expression_t *dot_expr = new_expression(ctx, EXPR_DOT, sizeof(*dot_expr)); CHECK_ERROR;
                                              (yyval.member) = new_member_expression(ctx, dot_expr, (yyvsp[0].string)); CHECK_ERROR; }
#line 2149 "parser.tab.c"
    break;

  case 52:
#line 239 "parser.y"
    { (yyval.boolean) = FALSE; }
#line 2155 "parser.tab.c"
    break;

  case 53:
#line 240 "parser.y"
    { (yyval.boolean) = TRUE; }
#line 2161 "parser.tab.c"
    break;

  case 54:
#line 243 "parser.y"
    { (yyval.dim_decl) = (yyvsp[0].dim_decl); }
#line 2167 "parser.tab.c"
    break;

  case 55:
#line 244 "parser.y"
    { (yyvsp[-2].dim_decl)->next = (yyvsp[0].dim_decl); (yyval.dim_decl) = (yyvsp[-2].dim_decl); }
#line 2173 "parser.tab.c"
    break;

  case 56:
#line 247 "parser.y"
    { (yyval.dim_decl) = new_dim_decl(ctx, (yyvsp[0].string), FALSE, NULL); CHECK_ERROR; }
#line 2179 "parser.tab.c"
    break;

  case 57:
#line 248 "parser.y"
    { (yyval.dim_decl) = new_dim_decl(ctx, (yyvsp[-3].string), TRUE, (yyvsp[-1].dim_list)); CHECK_ERROR; }
#line 2185 "parser.tab.c"
    break;

  case 58:
#line 249 "parser.y"
    { (yyval.dim_decl) = new_dim_decl(ctx, (yyvsp[-1].string), TRUE, NULL); CHECK_ERROR; }
#line 2191 "parser.tab.c"
    break;

  case 59:
#line 252 "parser.y"
    { (yyval.dim_list) = new_dim(ctx, (yyvsp[0].uint), NULL); }
#line 2197 "parser.tab.c"
    break;

  case 60:
#line 253 "parser.y"
    { (yyval.dim_list) = new_dim(ctx, (yyvsp[-2].uint), (yyvsp[0].dim_list)); }
#line 2203 "parser.tab.c"
    break;

  case 61:
#line 256 "parser.y"
    { (yyval.const_decl) = (yyvsp[0].const_decl); }
#line 2209 "parser.tab.c"
    break;

  case 62:
#line 257 "parser.y"
    { (yyvsp[-2].const_decl)->next = (yyvsp[0].const_decl); (yyval.const_decl) = (yyvsp[-2].const_decl); }
#line 2215 "parser.tab.c"
    break;

  case 63:
#line 260 "parser.y"
    { (yyval.const_decl) = new_const_decl(ctx, (yyvsp[-2].string), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2221 "parser.tab.c"
    break;

  case 64:
#line 263 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2227 "parser.tab.c"
    break;

  case 65:
#line 264 "parser.y"
    { (yyval.expression) = new_unary_expression(ctx, EXPR_NEG, (yyvsp[0].expression)); CHECK_ERROR; }
#line 2233 "parser.tab.c"
    break;

  case 66:
#line 267 "parser.y"
    { (yyval.boolean) = TRUE; }
#line 2239 "parser.tab.c"
    break;

  case 67:
#line 268 "parser.y"
    { (yyval.boolean) = FALSE; }
#line 2245 "parser.tab.c"
    break;

  case 68:
#line 271 "parser.y"
    { (yyval.expression) = NULL;}
#line 2251 "parser.tab.c"
    break;

  case 69:
#line 272 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2257 "parser.tab.c"
    break;

  case 70:
#line 276 "parser.y"
    { (yyval.statement) = new_if_statement(ctx, (yyvsp[-7].expression), (yyvsp[-4].statement), (yyvsp[-3].elseif), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2263 "parser.tab.c"
    break;

  case 71:
#line 277 "parser.y"
    { (yyval.statement) = new_if_statement(ctx, (yyvsp[-3].expression), (yyvsp[-1].statement), NULL, NULL); CHECK_ERROR; }
#line 2269 "parser.tab.c"
    break;

  case 72:
#line 279 "parser.y"
    { (yyval.statement) = new_if_statement(ctx, (yyvsp[-5].expression), (yyvsp[-3].statement), NULL, (yyvsp[-1].statement)); CHECK_ERROR; }
#line 2275 "parser.tab.c"
    break;

  case 75:
#line 286 "parser.y"
    { (yyval.elseif) = NULL; }
#line 2281 "parser.tab.c"
    break;

  case 76:
#line 287 "parser.y"
    { (yyval.elseif) = (yyvsp[0].elseif); }
#line 2287 "parser.tab.c"
    break;

  case 77:
#line 290 "parser.y"
    { (yyval.elseif) = (yyvsp[0].elseif); }
#line 2293 "parser.tab.c"
    break;

  case 78:
#line 291 "parser.y"
    { (yyvsp[-1].elseif)->next = (yyvsp[0].elseif); (yyval.elseif) = (yyvsp[-1].elseif); }
#line 2299 "parser.tab.c"
    break;

  case 79:
#line 295 "parser.y"
    { (yyval.elseif) = new_elseif_decl(ctx, (yyvsp[-3].expression), (yyvsp[0].statement)); }
#line 2305 "parser.tab.c"
    break;

  case 80:
#line 298 "parser.y"
    { (yyval.statement) = NULL; }
#line 2311 "parser.tab.c"
    break;

  case 81:
#line 299 "parser.y"
    { (yyval.statement) = (yyvsp[0].statement); }
#line 2317 "parser.tab.c"
    break;

  case 82:
#line 302 "parser.y"
    { (yyval.case_clausule) = NULL; }
#line 2323 "parser.tab.c"
    break;

  case 83:
#line 303 "parser.y"
    { (yyval.case_clausule) = new_case_clausule(ctx, NULL, (yyvsp[0].statement), NULL); }
#line 2329 "parser.tab.c"
    break;

  case 84:
#line 305 "parser.y"
    { (yyval.case_clausule) = new_case_clausule(ctx, (yyvsp[-3].expression), (yyvsp[-1].statement), (yyvsp[0].case_clausule)); }
#line 2335 "parser.tab.c"
    break;

  case 85:
#line 308 "parser.y"
    { (yyval.expression) = NULL; }
#line 2341 "parser.tab.c"
    break;

  case 86:
#line 309 "parser.y"
    { (yyval.expression) = (yyvsp[-1].expression); }
#line 2347 "parser.tab.c"
    break;

  case 87:
#line 312 "parser.y"
    { (yyval.expression) = NULL; }
#line 2353 "parser.tab.c"
    break;

  case 88:
#line 313 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2359 "parser.tab.c"
    break;

  case 89:
#line 316 "parser.y"
    { (yyval.expression) = NULL; }
#line 2365 "parser.tab.c"
    break;

  case 90:
#line 317 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2371 "parser.tab.c"
    break;

  case 91:
#line 320 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2377 "parser.tab.c"
    break;

  case 92:
#line 321 "parser.y"
    { (yyvsp[-2].expression)->next = (yyvsp[0].expression); (yyval.expression) = (yyvsp[-2].expression); }
#line 2383 "parser.tab.c"
    break;

  case 93:
#line 322 "parser.y"
    { (yyval.expression) = new_expression(ctx, EXPR_NOARG, 0); CHECK_ERROR; (yyval.expression)->next = (yyvsp[0].expression); }
#line 2389 "parser.tab.c"
    break;

  case 96:
#line 329 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2395 "parser.tab.c"
    break;

  case 97:
#line 330 "parser.y"
    { (yyvsp[-2].expression)->next = (yyvsp[0].expression); (yyval.expression) = (yyvsp[-2].expression); }
#line 2401 "parser.tab.c"
    break;

  case 98:
#line 333 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2407 "parser.tab.c"
    break;

  case 99:
#line 334 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_IMP, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2413 "parser.tab.c"
    break;

  case 100:
#line 337 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2419 "parser.tab.c"
    break;

  case 101:
#line 338 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_EQV, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2425 "parser.tab.c"
    break;

  case 102:
#line 341 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2431 "parser.tab.c"
    break;

  case 103:
#line 342 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_XOR, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2437 "parser.tab.c"
    break;

  case 104:
#line 345 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2443 "parser.tab.c"
    break;

  case 105:
#line 346 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_OR, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2449 "parser.tab.c"
    break;

  case 106:
#line 349 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2455 "parser.tab.c"
    break;

  case 107:
#line 350 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_AND, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2461 "parser.tab.c"
    break;

  case 108:
#line 353 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2467 "parser.tab.c"
    break;

  case 109:
#line 354 "parser.y"
    { (yyval.expression) = new_unary_expression(ctx, EXPR_NOT, (yyvsp[0].expression)); CHECK_ERROR; }
#line 2473 "parser.tab.c"
    break;

  case 110:
#line 357 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2479 "parser.tab.c"
    break;

  case 111:
#line 358 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_EQUAL, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2485 "parser.tab.c"
    break;

  case 112:
#line 359 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_NEQUAL, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2491 "parser.tab.c"
    break;

  case 113:
#line 360 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_GT, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2497 "parser.tab.c"
    break;

  case 114:
#line 361 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_LT, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2503 "parser.tab.c"
    break;

  case 115:
#line 362 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_GTEQ, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2509 "parser.tab.c"
    break;

  case 116:
#line 363 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_LTEQ, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2515 "parser.tab.c"
    break;

  case 117:
#line 364 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_IS, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2521 "parser.tab.c"
    break;

  case 118:
#line 367 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2527 "parser.tab.c"
    break;

  case 119:
#line 368 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_CONCAT, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2533 "parser.tab.c"
    break;

  case 120:
#line 371 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2539 "parser.tab.c"
    break;

  case 121:
#line 372 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_ADD, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2545 "parser.tab.c"
    break;

  case 122:
#line 373 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_SUB, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2551 "parser.tab.c"
    break;

  case 123:
#line 376 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2557 "parser.tab.c"
    break;

  case 124:
#line 377 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_MOD, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2563 "parser.tab.c"
    break;

  case 125:
#line 380 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2569 "parser.tab.c"
    break;

  case 126:
#line 382 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_IDIV, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2575 "parser.tab.c"
    break;

  case 127:
#line 385 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2581 "parser.tab.c"
    break;

  case 128:
#line 387 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_MUL, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2587 "parser.tab.c"
    break;

  case 129:
#line 389 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_DIV, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2593 "parser.tab.c"
    break;

  case 130:
#line 392 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2599 "parser.tab.c"
    break;

  case 131:
#line 393 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_EXP, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2605 "parser.tab.c"
    break;

  case 132:
#line 396 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2611 "parser.tab.c"
    break;

  case 133:
#line 397 "parser.y"
    { (yyval.expression) = new_unary_expression(ctx, EXPR_NEG, (yyvsp[0].expression)); CHECK_ERROR; }
#line 2617 "parser.tab.c"
    break;

  case 134:
#line 398 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2623 "parser.tab.c"
    break;

  case 135:
#line 401 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2629 "parser.tab.c"
    break;

  case 136:
#line 402 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2635 "parser.tab.c"
    break;

  case 137:
#line 403 "parser.y"
    { (yyval.expression) = new_new_expression(ctx, (yyvsp[0].string)); CHECK_ERROR; }
#line 2641 "parser.tab.c"
    break;

  case 138:
#line 406 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2647 "parser.tab.c"
    break;

  case 139:
#line 407 "parser.y"
    { (yyval.expression) = &(yyvsp[0].member)->expr; }
#line 2653 "parser.tab.c"
    break;

  case 140:
#line 408 "parser.y"
    { call_expression_t *expr = new_call_expression(ctx, (yyvsp[-1].expression), (yyvsp[0].expression)); CHECK_ERROR;
                                      (yyval.expression) = &expr->expr; }
#line 2660 "parser.tab.c"
    break;

  case 141:
#line 412 "parser.y"
    { (yyval.expression) = new_bool_expression(ctx, VARIANT_TRUE); CHECK_ERROR; }
#line 2666 "parser.tab.c"
    break;

  case 142:
#line 413 "parser.y"
    { (yyval.expression) = new_bool_expression(ctx, VARIANT_FALSE); CHECK_ERROR; }
#line 2672 "parser.tab.c"
    break;

  case 143:
#line 414 "parser.y"
    { (yyval.expression) = new_string_expression(ctx, (yyvsp[0].string)); CHECK_ERROR; }
#line 2678 "parser.tab.c"
    break;

  case 144:
#line 415 "parser.y"
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2684 "parser.tab.c"
    break;

  case 145:
#line 416 "parser.y"
    { (yyval.expression) = new_expression(ctx, EXPR_EMPTY, 0); CHECK_ERROR; }
#line 2690 "parser.tab.c"
    break;

  case 146:
#line 417 "parser.y"
    { (yyval.expression) = new_expression(ctx, EXPR_NULL, 0); CHECK_ERROR; }
#line 2696 "parser.tab.c"
    break;

  case 147:
#line 418 "parser.y"
    { (yyval.expression) = new_expression(ctx, EXPR_NOTHING, 0); CHECK_ERROR; }
#line 2702 "parser.tab.c"
    break;

  case 148:
#line 421 "parser.y"
    { (yyval.expression) = new_long_expression(ctx, EXPR_INT, 0); CHECK_ERROR; }
#line 2708 "parser.tab.c"
    break;

  case 149:
#line 422 "parser.y"
    { (yyval.expression) = new_long_expression(ctx, EXPR_INT, (yyvsp[0].integer)); CHECK_ERROR; }
#line 2714 "parser.tab.c"
    break;

  case 150:
#line 423 "parser.y"
    { (yyval.expression) = new_double_expression(ctx, (yyvsp[0].dbl)); CHECK_ERROR; }
#line 2720 "parser.tab.c"
    break;

  case 151:
#line 426 "parser.y"
    { (yyval.uint) = 0; }
#line 2726 "parser.tab.c"
    break;

  case 152:
#line 427 "parser.y"
    { (yyval.uint) = (yyvsp[0].integer); }
#line 2732 "parser.tab.c"
    break;

  case 153:
#line 430 "parser.y"
    { (yyval.expression) = new_unary_expression(ctx, EXPR_BRACKETS, (yyvsp[-1].expression)); }
#line 2738 "parser.tab.c"
    break;

  case 154:
#line 431 "parser.y"
    { (yyval.expression) = new_expression(ctx, EXPR_ME, 0); CHECK_ERROR; }
#line 2744 "parser.tab.c"
    break;

  case 155:
#line 434 "parser.y"
    { (yyvsp[-3].class_decl)->name = (yyvsp[-5].string); (yyval.class_decl) = (yyvsp[-3].class_decl); }
#line 2750 "parser.tab.c"
    break;

  case 156:
#line 437 "parser.y"
    { (yyval.class_decl) = new_class_decl(ctx); }
#line 2756 "parser.tab.c"
    break;

  case 157:
#line 438 "parser.y"
    { (yyval.class_decl) = add_class_function(ctx, new_class_decl(ctx), (yyvsp[0].func_decl)); CHECK_ERROR; }
#line 2762 "parser.tab.c"
    break;

  case 158:
#line 439 "parser.y"
    { (yyval.class_decl) = add_class_function(ctx, (yyvsp[0].class_decl), (yyvsp[-2].func_decl)); CHECK_ERROR; }
#line 2768 "parser.tab.c"
    break;

  case 159:
#line 441 "parser.y"
    { dim_decl_t *dim_decl = new_dim_decl(ctx, (yyvsp[0].string), FALSE, NULL); CHECK_ERROR;
                                                  (yyval.class_decl) = add_dim_prop(ctx, new_class_decl(ctx), dim_decl, (yyvsp[-1].uint)); CHECK_ERROR; }
#line 2775 "parser.tab.c"
    break;

  case 160:
#line 443 "parser.y"
    { dim_decl_t *dim_decl = new_dim_decl(ctx, (yyvsp[-2].string), FALSE, NULL); CHECK_ERROR;
                                                  (yyval.class_decl) = add_dim_prop(ctx, (yyvsp[0].class_decl), dim_decl, (yyvsp[-3].uint)); CHECK_ERROR; }
#line 2782 "parser.tab.c"
    break;

  case 161:
#line 445 "parser.y"
    { (yyval.class_decl) = add_dim_prop(ctx, new_class_decl(ctx), (yyvsp[0].dim_decl), 0); CHECK_ERROR; }
#line 2788 "parser.tab.c"
    break;

  case 162:
#line 446 "parser.y"
    { (yyval.class_decl) = add_dim_prop(ctx, (yyvsp[0].class_decl), (yyvsp[-2].dim_decl), 0); CHECK_ERROR; }
#line 2794 "parser.tab.c"
    break;

  case 163:
#line 447 "parser.y"
    { (yyval.class_decl) = add_class_function(ctx, new_class_decl(ctx), (yyvsp[0].func_decl)); CHECK_ERROR; }
#line 2800 "parser.tab.c"
    break;

  case 164:
#line 448 "parser.y"
    { (yyval.class_decl) = add_class_function(ctx, (yyvsp[0].class_decl), (yyvsp[-2].func_decl)); CHECK_ERROR; }
#line 2806 "parser.tab.c"
    break;

  case 165:
#line 452 "parser.y"
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-5].string), FUNC_PROPGET, (yyvsp[-8].uint), (yyvsp[-4].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2812 "parser.tab.c"
    break;

  case 166:
#line 454 "parser.y"
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-7].string), FUNC_PROPLET, (yyvsp[-10].uint), (yyvsp[-5].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2818 "parser.tab.c"
    break;

  case 167:
#line 456 "parser.y"
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-7].string), FUNC_PROPSET, (yyvsp[-10].uint), (yyvsp[-5].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2824 "parser.tab.c"
    break;

  case 168:
#line 460 "parser.y"
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-5].string), FUNC_SUB, (yyvsp[-7].uint), (yyvsp[-4].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2830 "parser.tab.c"
    break;

  case 169:
#line 462 "parser.y"
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-5].string), FUNC_FUNCTION, (yyvsp[-7].uint), (yyvsp[-4].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2836 "parser.tab.c"
    break;

  case 170:
#line 465 "parser.y"
    { (yyval.uint) = 0; }
#line 2842 "parser.tab.c"
    break;

  case 171:
#line 466 "parser.y"
    { (yyval.uint) = (yyvsp[0].uint); }
#line 2848 "parser.tab.c"
    break;

  case 172:
#line 469 "parser.y"
    { (yyval.uint) = STORAGE_IS_DEFAULT; }
#line 2854 "parser.tab.c"
    break;

  case 173:
#line 470 "parser.y"
    { (yyval.uint) = 0; }
#line 2860 "parser.tab.c"
    break;

  case 174:
#line 471 "parser.y"
    { (yyval.uint) = STORAGE_IS_PRIVATE; }
#line 2866 "parser.tab.c"
    break;

  case 175:
#line 474 "parser.y"
    { (yyval.arg_decl) = NULL; }
#line 2872 "parser.tab.c"
    break;

  case 176:
#line 475 "parser.y"
    { (yyval.arg_decl) = (yyvsp[-1].arg_decl); }
#line 2878 "parser.tab.c"
    break;

  case 177:
#line 478 "parser.y"
    { (yyval.arg_decl) = (yyvsp[0].arg_decl); }
#line 2884 "parser.tab.c"
    break;

  case 178:
#line 479 "parser.y"
    { (yyvsp[-2].arg_decl)->next = (yyvsp[0].arg_decl); (yyval.arg_decl) = (yyvsp[-2].arg_decl); }
#line 2890 "parser.tab.c"
    break;

  case 179:
#line 482 "parser.y"
    { (yyval.arg_decl) = new_argument_decl(ctx, (yyvsp[-1].string), TRUE); }
#line 2896 "parser.tab.c"
    break;

  case 180:
#line 483 "parser.y"
    { (yyval.arg_decl) = new_argument_decl(ctx, (yyvsp[-1].string), TRUE); }
#line 2902 "parser.tab.c"
    break;

  case 181:
#line 484 "parser.y"
    { (yyval.arg_decl) = new_argument_decl(ctx, (yyvsp[-1].string), FALSE); }
#line 2908 "parser.tab.c"
    break;

  case 182:
#line 488 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 2914 "parser.tab.c"
    break;

  case 183:
#line 489 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 2920 "parser.tab.c"
    break;

  case 184:
#line 490 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 2926 "parser.tab.c"
    break;

  case 185:
#line 491 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 2932 "parser.tab.c"
    break;

  case 186:
#line 492 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 2938 "parser.tab.c"
    break;

  case 187:
#line 493 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 2944 "parser.tab.c"
    break;

  case 188:
#line 497 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 2950 "parser.tab.c"
    break;

  case 189:
#line 498 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 2956 "parser.tab.c"
    break;

  case 190:
#line 499 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 2962 "parser.tab.c"
    break;

  case 191:
#line 500 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 2968 "parser.tab.c"
    break;

  case 192:
#line 501 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 2974 "parser.tab.c"
    break;

  case 193:
#line 502 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 2980 "parser.tab.c"
    break;

  case 194:
#line 503 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 2986 "parser.tab.c"
    break;

  case 195:
#line 504 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 2992 "parser.tab.c"
    break;

  case 196:
#line 505 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 2998 "parser.tab.c"
    break;

  case 197:
#line 506 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3004 "parser.tab.c"
    break;

  case 198:
#line 507 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3010 "parser.tab.c"
    break;

  case 199:
#line 508 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3016 "parser.tab.c"
    break;

  case 200:
#line 509 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3022 "parser.tab.c"
    break;

  case 201:
#line 510 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3028 "parser.tab.c"
    break;

  case 202:
#line 511 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3034 "parser.tab.c"
    break;

  case 203:
#line 512 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3040 "parser.tab.c"
    break;

  case 204:
#line 513 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3046 "parser.tab.c"
    break;

  case 205:
#line 514 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3052 "parser.tab.c"
    break;

  case 206:
#line 515 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3058 "parser.tab.c"
    break;

  case 207:
#line 516 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3064 "parser.tab.c"
    break;

  case 208:
#line 517 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3070 "parser.tab.c"
    break;

  case 209:
#line 518 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3076 "parser.tab.c"
    break;

  case 210:
#line 519 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3082 "parser.tab.c"
    break;

  case 211:
#line 520 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3088 "parser.tab.c"
    break;

  case 212:
#line 521 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3094 "parser.tab.c"
    break;

  case 213:
#line 522 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3100 "parser.tab.c"
    break;

  case 214:
#line 523 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3106 "parser.tab.c"
    break;

  case 215:
#line 524 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3112 "parser.tab.c"
    break;

  case 216:
#line 525 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3118 "parser.tab.c"
    break;

  case 217:
#line 526 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3124 "parser.tab.c"
    break;

  case 218:
#line 527 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3130 "parser.tab.c"
    break;

  case 219:
#line 528 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3136 "parser.tab.c"
    break;

  case 220:
#line 529 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3142 "parser.tab.c"
    break;

  case 221:
#line 530 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3148 "parser.tab.c"
    break;

  case 222:
#line 531 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3154 "parser.tab.c"
    break;

  case 223:
#line 532 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3160 "parser.tab.c"
    break;

  case 224:
#line 533 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3166 "parser.tab.c"
    break;

  case 225:
#line 534 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3172 "parser.tab.c"
    break;

  case 226:
#line 535 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3178 "parser.tab.c"
    break;

  case 227:
#line 536 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3184 "parser.tab.c"
    break;

  case 228:
#line 537 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3190 "parser.tab.c"
    break;

  case 229:
#line 538 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3196 "parser.tab.c"
    break;

  case 230:
#line 539 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3202 "parser.tab.c"
    break;

  case 231:
#line 540 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3208 "parser.tab.c"
    break;

  case 232:
#line 541 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3214 "parser.tab.c"
    break;

  case 233:
#line 542 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3220 "parser.tab.c"
    break;

  case 234:
#line 543 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3226 "parser.tab.c"
    break;

  case 235:
#line 544 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3232 "parser.tab.c"
    break;

  case 236:
#line 545 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3238 "parser.tab.c"
    break;

  case 237:
#line 546 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3244 "parser.tab.c"
    break;

  case 238:
#line 547 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3250 "parser.tab.c"
    break;

  case 239:
#line 548 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3256 "parser.tab.c"
    break;

  case 240:
#line 549 "parser.y"
    { (yyval.string) = (yyvsp[0].string); }
#line 3262 "parser.tab.c"
    break;


#line 3266 "parser.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (ctx, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (ctx, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, ctx);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, ctx);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (ctx, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, ctx);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, ctx);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 558 "parser.y"


static int parser_error(parser_ctx_t *ctx, const char *str)
{
    return 0;
}

static void source_add_statement(parser_ctx_t *ctx, statement_t *stat)
{
    if(!stat)
        return;

    if(ctx->stats) {
        ctx->stats_tail->next = stat;
        ctx->stats_tail = stat;
    }else {
        ctx->stats = ctx->stats_tail = stat;
    }
}

static void source_add_class(parser_ctx_t *ctx, class_decl_t *class_decl)
{
    class_decl->next = ctx->class_decls;
    ctx->class_decls = class_decl;
}

static void parse_complete(parser_ctx_t *ctx, BOOL option_explicit)
{
    ctx->parse_complete = TRUE;
    ctx->option_explicit = option_explicit;
}

static void handle_isexpression_script(parser_ctx_t *ctx, expression_t *expr)
{
    retval_statement_t *stat;

    ctx->parse_complete = TRUE;
    if(!expr)
        return;

    stat = new_statement(ctx, STAT_RETVAL, sizeof(*stat));
    if(!stat)
        return;

    stat->expr = expr;
    ctx->stats = &stat->stat;
}

static void *new_expression(parser_ctx_t *ctx, expression_type_t type, size_t size)
{
    expression_t *expr;

    expr = parser_alloc(ctx, size ? size : sizeof(*expr));
    if(expr) {
        expr->type = type;
        expr->next = NULL;
    }

    return expr;
}

static expression_t *new_bool_expression(parser_ctx_t *ctx, VARIANT_BOOL value)
{
    bool_expression_t *expr;

    expr = new_expression(ctx, EXPR_BOOL, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_string_expression(parser_ctx_t *ctx, const WCHAR *value)
{
    string_expression_t *expr;

    expr = new_expression(ctx, EXPR_STRING, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_long_expression(parser_ctx_t *ctx, expression_type_t type, LONG value)
{
    int_expression_t *expr;

    expr = new_expression(ctx, type, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_double_expression(parser_ctx_t *ctx, double value)
{
    double_expression_t *expr;

    expr = new_expression(ctx, EXPR_DOUBLE, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_unary_expression(parser_ctx_t *ctx, expression_type_t type, expression_t *subexpr)
{
    unary_expression_t *expr;

    expr = new_expression(ctx, type, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->subexpr = subexpr;
    return &expr->expr;
}

static expression_t *new_binary_expression(parser_ctx_t *ctx, expression_type_t type, expression_t *left, expression_t *right)
{
    binary_expression_t *expr;

    expr = new_expression(ctx, type, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->left = left;
    expr->right = right;
    return &expr->expr;
}

static member_expression_t *new_member_expression(parser_ctx_t *ctx, expression_t *obj_expr, const WCHAR *identifier)
{
    member_expression_t *expr;

    expr = new_expression(ctx, EXPR_MEMBER, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->obj_expr = obj_expr;
    expr->identifier = identifier;
    return expr;
}

static call_expression_t *new_call_expression(parser_ctx_t *ctx, expression_t *expr, expression_t *arguments)
{
    call_expression_t *call_expr;

    call_expr = new_expression(ctx, EXPR_CALL, sizeof(*call_expr));
    if(!call_expr)
        return NULL;

    call_expr->call_expr = expr;
    call_expr->args = arguments;
    return call_expr;
}

static call_expression_t *make_call_expression(parser_ctx_t *ctx, expression_t *callee_expr, expression_t *arguments)
{
    call_expression_t *call_expr;

    if(callee_expr->type == EXPR_MEMBER)
        return new_call_expression(ctx, callee_expr, arguments);
    if(callee_expr->type != EXPR_CALL) {
        FIXME("Unhandled for expr type %u\n", callee_expr->type);
        ctx->hres = E_FAIL;
        return NULL;
    }
    call_expr = (call_expression_t*)callee_expr;
    if(!call_expr->args) {
        call_expr->args = arguments;
    }else if(call_expr->args->next) {
        FIXME("Invalid syntax: invalid use of parentheses for arguments\n");
        ctx->hres = E_FAIL;
        return NULL;
    }else if(arguments->type != EXPR_NOARG) {
        FIXME("Invalid syntax: missing comma\n");
        ctx->hres = E_FAIL;
        return NULL;
    }else {
        call_expr->args->next = arguments->next;
    }

    return call_expr;
}

static expression_t *new_new_expression(parser_ctx_t *ctx, const WCHAR *identifier)
{
    string_expression_t *expr;

    expr = new_expression(ctx, EXPR_NEW, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = identifier;
    return &expr->expr;
}

static void *new_statement(parser_ctx_t *ctx, statement_type_t type, size_t size)
{
    statement_t *stat;

    stat = parser_alloc(ctx, size ? size : sizeof(*stat));
    if(stat) {
        stat->type = type;
        stat->next = NULL;
    }

    return stat;
}

static statement_t *new_call_statement(parser_ctx_t *ctx, BOOL is_strict, expression_t *expr)
{
    call_expression_t *call_expr = NULL;
    call_statement_t *stat;

    stat = new_statement(ctx, STAT_CALL, sizeof(*stat));
    if(!stat)
        return NULL;

    switch(expr->type) {
    case EXPR_MEMBER:
        call_expr = new_call_expression(ctx, expr, NULL);
        break;
    case EXPR_CALL:
        call_expr = (call_expression_t*)expr;
        break;
    default:
        FIXME("Unsupported expr type %u\n", expr->type);
        ctx->hres = E_NOTIMPL;
    }
    if(!call_expr)
        return NULL;

    stat->expr = call_expr;
    stat->is_strict = is_strict;
    return &stat->stat;
}

static statement_t *new_assign_statement(parser_ctx_t *ctx, expression_t *left, expression_t *right)
{
    assign_statement_t *stat;

    stat = new_statement(ctx, STAT_ASSIGN, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->value_expr = right;

    if(left->type == EXPR_CALL) {
        stat->left_expr = (call_expression_t*)left;
    }else {
        stat->left_expr = new_call_expression(ctx, left, NULL);
        if(!stat->left_expr)
            return NULL;
    }

    return &stat->stat;
}

static statement_t *new_set_statement(parser_ctx_t *ctx, member_expression_t *left, expression_t *arguments, expression_t *right)
{
    assign_statement_t *stat;

    stat = new_statement(ctx, STAT_SET, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->value_expr = right;
    stat->left_expr = new_call_expression(ctx, &left->expr, arguments);
    if(!stat->left_expr)
        return NULL;

    return &stat->stat;
}

static dim_decl_t *new_dim_decl(parser_ctx_t *ctx, const WCHAR *name, BOOL is_array, dim_list_t *dims)
{
    dim_decl_t *decl;

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->name = name;
    decl->is_array = is_array;
    decl->dims = dims;
    decl->next = NULL;
    return decl;
}

static dim_list_t *new_dim(parser_ctx_t *ctx, unsigned val, dim_list_t *next)
{
    dim_list_t *ret;

    ret = parser_alloc(ctx, sizeof(*ret));
    if(!ret)
        return NULL;

    ret->val = val;
    ret->next = next;
    return ret;
}

static statement_t *new_dim_statement(parser_ctx_t *ctx, dim_decl_t *decls)
{
    dim_statement_t *stat;

    stat = new_statement(ctx, STAT_DIM, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->dim_decls = decls;
    return &stat->stat;
}

static statement_t *new_redim_statement(parser_ctx_t *ctx, const WCHAR *identifier, BOOL preserve, expression_t *dims)
{
    redim_statement_t *stat;

    stat = new_statement(ctx, STAT_REDIM, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->identifier = identifier;
    stat->preserve = preserve;
    stat->dims = dims;
    return &stat->stat;
}

static elseif_decl_t *new_elseif_decl(parser_ctx_t *ctx, expression_t *expr, statement_t *stat)
{
    elseif_decl_t *decl;

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->expr = expr;
    decl->stat = stat;
    decl->next = NULL;
    return decl;
}

static statement_t *new_while_statement(parser_ctx_t *ctx, statement_type_t type, expression_t *expr, statement_t *body)
{
    while_statement_t *stat;

    stat = new_statement(ctx, type, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->body = body;
    return &stat->stat;
}

static statement_t *new_forto_statement(parser_ctx_t *ctx, const WCHAR *identifier, expression_t *from_expr,
        expression_t *to_expr, expression_t *step_expr, statement_t *body)
{
    forto_statement_t *stat;

    stat = new_statement(ctx, STAT_FORTO, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->identifier = identifier;
    stat->from_expr = from_expr;
    stat->to_expr = to_expr;
    stat->step_expr = step_expr;
    stat->body = body;
    return &stat->stat;
}

static statement_t *new_foreach_statement(parser_ctx_t *ctx, const WCHAR *identifier, expression_t *group_expr,
        statement_t *body)
{
    foreach_statement_t *stat;

    stat = new_statement(ctx, STAT_FOREACH, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->identifier = identifier;
    stat->group_expr = group_expr;
    stat->body = body;
    return &stat->stat;
}

static statement_t *new_if_statement(parser_ctx_t *ctx, expression_t *expr, statement_t *if_stat, elseif_decl_t *elseif_decl,
        statement_t *else_stat)
{
    if_statement_t *stat;

    stat = new_statement(ctx, STAT_IF, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->if_stat = if_stat;
    stat->elseifs = elseif_decl;
    stat->else_stat = else_stat;
    return &stat->stat;
}

static statement_t *new_select_statement(parser_ctx_t *ctx, expression_t *expr, case_clausule_t *case_clausules)
{
    select_statement_t *stat;

    stat = new_statement(ctx, STAT_SELECT, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->case_clausules = case_clausules;
    return &stat->stat;
}

static statement_t *new_with_statement(parser_ctx_t *ctx, expression_t *expr, statement_t *body)
{
    with_statement_t *stat;

    stat = new_statement(ctx, STAT_WITH, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->body = body;
    return &stat->stat;
}

static case_clausule_t *new_case_clausule(parser_ctx_t *ctx, expression_t *expr, statement_t *stat, case_clausule_t *next)
{
    case_clausule_t *ret;

    ret = parser_alloc(ctx, sizeof(*ret));
    if(!ret)
        return NULL;

    ret->expr = expr;
    ret->stat = stat;
    ret->next = next;
    return ret;
}

static statement_t *new_onerror_statement(parser_ctx_t *ctx, BOOL resume_next)
{
    onerror_statement_t *stat;

    stat = new_statement(ctx, STAT_ONERROR, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->resume_next = resume_next;
    return &stat->stat;
}

static arg_decl_t *new_argument_decl(parser_ctx_t *ctx, const WCHAR *name, BOOL by_ref)
{
    arg_decl_t *arg_decl;

    arg_decl = parser_alloc(ctx, sizeof(*arg_decl));
    if(!arg_decl)
        return NULL;

    arg_decl->name = name;
    arg_decl->by_ref = by_ref;
    arg_decl->next = NULL;
    return arg_decl;
}

static function_decl_t *new_function_decl(parser_ctx_t *ctx, const WCHAR *name, function_type_t type,
        unsigned storage_flags, arg_decl_t *arg_decl, statement_t *body)
{
    function_decl_t *decl;

    if(storage_flags & STORAGE_IS_DEFAULT) {
        if(type == FUNC_PROPGET) {
            type = FUNC_DEFGET;
        }else {
            FIXME("Invalid default property\n");
            ctx->hres = E_FAIL;
            return NULL;
        }
    }

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->name = name;
    decl->type = type;
    decl->is_public = !(storage_flags & STORAGE_IS_PRIVATE);
    decl->args = arg_decl;
    decl->body = body;
    decl->next = NULL;
    decl->next_prop_func = NULL;
    return decl;
}

static statement_t *new_function_statement(parser_ctx_t *ctx, function_decl_t *decl)
{
    function_statement_t *stat;

    stat = new_statement(ctx, STAT_FUNC, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->func_decl = decl;
    return &stat->stat;
}

static class_decl_t *new_class_decl(parser_ctx_t *ctx)
{
    class_decl_t *class_decl;

    class_decl = parser_alloc(ctx, sizeof(*class_decl));
    if(!class_decl)
        return NULL;

    class_decl->funcs = NULL;
    class_decl->props = NULL;
    class_decl->next = NULL;
    return class_decl;
}

static class_decl_t *add_class_function(parser_ctx_t *ctx, class_decl_t *class_decl, function_decl_t *decl)
{
    function_decl_t *iter;

    for(iter = class_decl->funcs; iter; iter = iter->next) {
        if(!wcsicmp(iter->name, decl->name)) {
            if(decl->type == FUNC_SUB || decl->type == FUNC_FUNCTION) {
                FIXME("Redefinition of %s::%s\n", debugstr_w(class_decl->name), debugstr_w(decl->name));
                ctx->hres = E_FAIL;
                return NULL;
            }

            while(1) {
                if(iter->type == decl->type) {
                    FIXME("Redefinition of %s::%s\n", debugstr_w(class_decl->name), debugstr_w(decl->name));
                    ctx->hres = E_FAIL;
                    return NULL;
                }
                if(!iter->next_prop_func)
                    break;
                iter = iter->next_prop_func;
            }

            iter->next_prop_func = decl;
            return class_decl;
        }
    }

    decl->next = class_decl->funcs;
    class_decl->funcs = decl;
    return class_decl;
}

static class_decl_t *add_dim_prop(parser_ctx_t *ctx, class_decl_t *class_decl, dim_decl_t *dim_decl, unsigned storage_flags)
{
    if(storage_flags & STORAGE_IS_DEFAULT) {
        FIXME("variant prop van't be default value\n");
        ctx->hres = E_FAIL;
        return NULL;
    }

    dim_decl->is_public = !(storage_flags & STORAGE_IS_PRIVATE);
    dim_decl->next = class_decl->props;
    class_decl->props = dim_decl;
    return class_decl;
}

static const_decl_t *new_const_decl(parser_ctx_t *ctx, const WCHAR *name, expression_t *expr)
{
    const_decl_t *decl;

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->name = name;
    decl->value_expr = expr;
    decl->next = NULL;
    return decl;
}

static statement_t *new_const_statement(parser_ctx_t *ctx, const_decl_t *decls)
{
    const_statement_t *stat;

    stat = new_statement(ctx, STAT_CONST, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->decls = decls;
    return &stat->stat;
}

static statement_t *link_statements(statement_t *head, statement_t *tail)
{
    statement_t *iter;

    for(iter = head; iter->next; iter = iter->next);
    iter->next = tail;

    return head;
}

void *parser_alloc(parser_ctx_t *ctx, size_t size)
{
    void *ret;

    ret = heap_pool_alloc(&ctx->heap, size);
    if(!ret)
        ctx->hres = E_OUTOFMEMORY;
    return ret;
}

HRESULT parse_script(parser_ctx_t *ctx, const WCHAR *code, const WCHAR *delimiter, DWORD flags)
{
    static const WCHAR html_delimiterW[] = {'<','/','s','c','r','i','p','t','>',0};

    ctx->code = ctx->ptr = code;
    ctx->end = ctx->code + lstrlenW(ctx->code);

    heap_pool_init(&ctx->heap);

    ctx->parse_complete = FALSE;
    ctx->hres = S_OK;

    ctx->last_token = tNL;
    ctx->last_nl = 0;
    ctx->stats = ctx->stats_tail = NULL;
    ctx->class_decls = NULL;
    ctx->option_explicit = FALSE;
    ctx->is_html = delimiter && !wcsicmp(delimiter, html_delimiterW);

    if(flags & SCRIPTTEXT_ISEXPRESSION)
        ctx->last_token = tEXPRESSION;

    parser_parse(ctx);

    if(FAILED(ctx->hres))
        return ctx->hres;
    if(!ctx->parse_complete) {
        FIXME("parser failed around %s\n", debugstr_w(ctx->code+20 > ctx->ptr ? ctx->code : ctx->ptr-20));
        return E_FAIL;
    }

    return S_OK;
}

void parser_release(parser_ctx_t *ctx)
{
    heap_pool_free(&ctx->heap);
}
